<?php
if (!isset($debug))
{
	session_name('pst2'); 
	session_start();
	require ("include/cfg.php");
	require ("include/".PS_EV.".php");
	if (!isset($_SESSION['PSproject'])||!isset($_SESSION['PSscene'])||!isset($_POST['cmd']))
	{
		$message=array(2,"Unknow command");
		echo json_encode($message);
		return;
	}
	$dir="projects/".$_SESSION['PSproject']."/".$_SESSION['PSscene'];
	switch ($_POST['cmd'])
	{
		case "photo":
			$_SESSION['anmethod']=0;
			$GLOBALS['chaine']=json_decode($_POST['data']);
			$_SESSION['photomode']=true;
			ps_initSession(true);
			$xs=$dir."/xs-".$_SESSION['PSscene'].".jpg";
			$dir.="/".$_SESSION['PSscene'].".jpg";
			if (file_exists($dir))		unlink($dir);
			if (file_exists($xs))		unlink($xs);

			ps_Render($dir,true);
			if (file_exists("$dir"))
			{
				ps_exec(PS_CONVCMD." $dir -resize x160 $xs");
				$message=array(0,"Render : $dir");
				// composition d'un xs
			}
			else						$message=array(2,"Error !");
			echo json_encode($message);
			break;
		case "prepanim":
			$GLOBALS['chaine']=json_decode($_POST['data']);
			$_SESSION['photomode']=false;
			$_SESSION['andebug']=$_POST['debug'];
			$_SESSION['anmethod']=$_POST['method'];
			$_SESSION['ankeep']=$_POST['keep'];
			ps_initSession(true);
			ps_message("Version du moteur de rendu : ".PS_VERSION." / ".PS_EV,1);
			ps_message("Rendu de l'animation ".$_SESSION['PSscene']);
			ps_imagectrl();
			//if (_O(0)->motionblur)	ps_message("Flou de mouvement activé. Cette option expérimentale risque de ralentir fortement le rendu",1);
			switch ($_SESSION['anmethod'])
			{
				case 0:
					ps_message("Méthode rendu direct activée.");
					ps_message("Tentative de suppression des anciens fichiers");
					ps_rmfiles("$dir/anim/frame*.jpg");
					if (file_exists("$dir/".$_SESSION['PSscene'].".mp4"))
					{
						ps_message("Effacement de l'ancienne animation");
						unlink("$dir/".$_SESSION['PSscene'].".mp4");
					}
					break;
				case 1:
					// création nom de tâche
					$_SESSION['script']=uniqid("pst");
					$_SESSION['scriptdir']=$dir;
					$_SESSION['scriptdata']=array();
					ps_message("Génération du script : ".$_SESSION['script']);
					break;
				case 2:
					if (PS_WINDOWS)		$_SESSION['script']=win_filter("$dir/".$_SESSION['PSscene'].".bat");
					else						$_SESSION['script']="$dir/".$_SESSION['PSscene'].".linux";
					ps_message("Génération du script : ".$_SESSION['script']);
					$content=PS_SHHEADER.PS_ENDOFLINE.PS_REM." ".$_SESSION['PSscene'].PS_ENDOFLINE;
					$content.=PS_REM." Picstory engine version ".PS_VERSION.PS_ENDOFLINE;
					$content.=PS_DELETE.win_filter(" $dir/anim/frame*.jpg").PS_ENDOFLINE;
					file_put_contents($_SESSION['script'],$content);
					break;
				default:
					$_SESSION['message'][0]=2;
					$_SESSION['message'][1]="Cette méthode n'est pas (encore) gérée par le moteur.";
					break;
			}
			echo json_encode($_SESSION['message']);
			break;
		case "anim":
			$GLOBALS['chaine']=json_decode($_POST['data']);
			ps_initSession(false);
			$dir.="/anim/frame".sprintf("%04d", $_POST['frame']).".jpg";
			$_SESSION['framenumber']=$_POST['frame'];
			$cmd=ps_Render($dir,false);
			switch ($_SESSION['anmethod'])
			{
				case 1:
					$_SESSION['scriptdata'][]=$cmd;
					break;
				case 2:
					file_put_contents($_SESSION['script'],$cmd.PS_ENDOFLINE,FILE_APPEND);
					break;
				default:
					break;
			}
			if (PS_VERBOSE && ($_SESSION['nbobject']!=$_SESSION['oldobject'] || $_SESSION['nbrot']!=$_SESSION['oldrot']))
						ps_message("Image ".$_POST['frame']." (".$_SESSION['nbobject']." objet(s)/".$_SESSION['nbrot']." rotation(s))");
			echo json_encode($_SESSION['message']);
			break;
		case "finalize":
			$_SESSION['message']=array();
			$GLOBALS['chaine']=json_decode($_POST['data']);
			$main=_O(0);
			switch ($_SESSION['anmethod'])
			{
				case 0:
				case 1:
				if ($_SESSION['anmethod']==0)		$direct=true;
				else														$direct=false;

				if (isset($_POST['sound']) && $_POST['sound'])		$animname="$dir/tmp-".$_SESSION['PSscene'].".mp4";
				else																					$animname="$dir/".$_SESSION['PSscene'].".mp4";

				$cmd=PS_FFCMD." -y -r ".$main->framerate." -i $dir/anim/frame%04d.jpg -r ".$main->framerate." -vcodec libx264 -crf ".$main->crf." -pix_fmt yuv420p $animname";

				if ($direct)
				{
					ps_message("Finalisation : ".$cmd);
					ps_exec($cmd);
				}
				else
				{
					ps_message("Commande ffmpeg : ".$cmd);
					$_SESSION['scriptdata'][]=$cmd;
				}
				/* ajout du son */
				if (isset($_POST['sound']) && $_POST['sound'])
				{
					if ($main->length > ($main->sndlen-$main->sndstrt))	$short="";
					else																						$short=" -shortest";
					ps_message("Ajout du son ".$main->snd);
					$sndname="projects/".$_SESSION['PSproject']."/commons/sounds/".$main->snd;
					$cmd=PS_FFCMD." -y -ss ".$main->sndstrt." -i $sndname -i $animname -codec copy$short $dir/".$_SESSION['PSscene'].".mp4";
					ps_message("Commande ffmpeg : ".$cmd);
					if ($direct)
					{
						ps_exec($cmd);
						unlink($animname);
					}
					else
					{
						$_SESSION['scriptdata'][]=$cmd;
						if (PS_WINDOWS) 	$_SESSION['scriptdata'][]="del /F $animname";
						else								$_SESSION['scriptdata'][]="rm -f $animname";
					}
				}
				/* file */
				if ($direct)
				{
					if ($_SESSION['ankeep'])	ps_message("Les images de travail ont été laissées sur le serveur",1);
					else											ps_rmfiles("$dir/anim/frame*.jpg");
				}
				else
				{
						ps_message("Écriture des fichiers tasks");
						file_put_contents("tasks/".$_SESSION['script'].".tsk","<waiting>\n\n");
						file_put_contents("tasks/".$_SESSION['script'].".tsk",$_SESSION['scriptdir'],FILE_APPEND);
						file_put_contents("tasks/".$_SESSION['script'].".dat",json_encode($_SESSION['scriptdata']));
						ps_message("Lancement du script ".$_SESSION['script']);
						if (PS_WINDOWS)	pclose(popen(PS_ATCMD." ".$_SESSION['script'],"r"));  
						else								ps_exec(PS_ATCMD." ".$_SESSION['script']." > /dev/null &");
				}
				break;
				case 2:
					$cmd=PS_FFCMD." -y -r ".$main->framerate." -i $dir/anim/frame$frame%04d.jpg -r ".$main->framerate." -vcodec libx264 -crf ". $main->crf." -pix_fmt yuv420p $dir/".$_SESSION['PSscene'].".mp4";
					ps_message("Commande ffmpeg : ".$cmd);
					file_put_contents($_SESSION['script'],$cmd,FILE_APPEND);
					break;
				default:
					break;
			}
			echo json_encode($_SESSION['message']);
			break;
		default:
			echo ("err");
			break;
	}
}
function win_filter($cmd)
{
	if (PS_WINDOWS)	$cmd=str_replace('/','\\',$cmd);
	return $cmd;
}
/* initialisations */
function ps_initSession($reset)
{
	$_SESSION['message']=array(0,"");
	if (!$reset)
	{
		$_SESSION['oldobject']=$_SESSION['nbobject'];
		$_SESSION['oldrot']=$_SESSION['nbrot'];
		$_SESSION['nbobject']=0;
		$_SESSION['nbrot']=0;
		return;
	}
	$_SESSION['oldobject']=0;
	$_SESSION['oldrot']=0;
	$_SESSION['nbobject']=0;
	$_SESSION['nbrot']=0;
	$_SESSION['mblur']=array();				// garde la trace du déplacement image d'avant
}
/* message de retour */
function ps_message($message,$level=0)
{
	if (PS_LOGIT)		file_put_contents("log/console.log",date(DATE_RFC2822)." ".$message.PS_ENDOFLINE,FILE_APPEND);
	if (!isset($_SESSION['andebug']) || !$_SESSION['andebug'] || $_SESSION['photomode'])	return;
	$_SESSION['message'][]=$level;
	$_SESSION['message'][]=$message;
}
/* rendering anim or photo */
function ps_Render($dir,$photomode)
{
	/* résolution image */
	$main=_O(0);
	if ($photomode)
	{
		$height=$main->photores;
		$width=($main->photores*$main->factorx)/$main->factory;
		$_SESSION['motionblur']=false;
		$width=floor($width/2)*2;
	}
	else
	{
		$height=$main->resolution;
		$width=($main->resolution*$main->factorx)/$main->factory;
		$width=floor($width/2)*2;
		$width*=$main->canvas;
		$height*=$main->canvas;
		$_SESSION['motionblur']=$main->motionblur;
	}
	$_SESSION['fheight']=$height;
	$_SESSION['fwidth']=$width;
	/* ligne de commande */
	if (PS_CONVOPTS)		$cmdline=PS_CONVCMD." ".PS_CONVOPTS." -size ".$width."x".$height." xc:black";
	else						$cmdline=PS_CONVCMD." -size ".$width."x".$height." xc:black";
	/* On boucle sur les enfants */
	$cmdline.=ps_getImage($main->rootuid,$width,$height);
	/* si windows remove des \ */
	if (PS_WINDOWS)
	{
		$cmdline=stripslashes ($cmdline); //str_replace("\\","",$cmdline);
		$cmdline=str_replace('/','\\',$cmdline); 
		$dir=str_replace('/','\\',$dir);
	}
	/* retour */
	if ($main->canvas!=1 && !$photomode)	$canvas=" -resize ".($width/$main->canvas);
	else						$canvas="";
	/* fin de la commande */
	if (!$_SESSION['photomode'] && $_SESSION['framenumber'] && $_SESSION['oldcmd']==$cmdline)
	{
		if (PS_VERBOSE)	ps_message("Optimisation, recopie de l'image précédente ".sprintf("%04d", $_SESSION ['framenumber']-1));
		$cmdline=PS_COPYCMD." ".win_filter(substr_replace($dir,sprintf("%04d", $_SESSION ['framenumber']-1).".jpg",-8))." ".win_filter($dir);
	}
	else
	{
		if (!$_SESSION['photomode'])	$_SESSION['oldcmd']=$cmdline;
		$cmdline.=$canvas." -colorspace RGB -type truecolor ".$dir;
	}
	/* exécution */
	if ($_SESSION['anmethod']==0)	return ps_exec($cmdline);
	else								return $cmdline;
	//echo ("<script>console.log('$cmdline');</script>");
}
/* traitement d'un objet */
function ps_getImage($uid,$width,$height)
{
	/* variables de travail */
	$return="";
	$object=_O($uid);
	$effect=$object->actualeffect;
	/* boucle chainage */
	if ($object->type<2)
	{
		if ($object->firstchild && !$effect->show && $effect->opacity>0)
		{
			// on règle les dimensions
			$effect->width*=$width;
			if ($effect->height===false)		$effect->height=$height;
			else								$effect->height*=$height;
			// les offsets
			$effect->x*=$width;
			$effect->y*=$height;
			$return.=ps_getImage($object->firstchild,$width,$height);
		}
	}
	else		$return.=ps_renderPic($object,$effect,$width,$height);
	if ($object->next)	$return.=ps_getImage($object->next,$width,$height);
	return $return;
}

/* Pointeur objet */
function _O($uid)
{
	return $GLOBALS['chaine'][$uid];
}
/* contrôle des images */
function ps_imagectrl()
{
	$main=_O(0);
	$missing=0;
	$nbobject=0;
	// on boucle
	ps_recurctrl($main->rootuid,$missing,$nbobject);
	if ($missing)
	{
		$_SESSION['message'][0]=2;
		$_SESSION['message'][1]="$missing Image(s) manquante(s), abandon !";
	}
	else		ps_message($nbobject." image(s) contrôlée(s)");
}
function ps_recurctrl($uid,&$missing,&$nbobject)
{
	$object=_O($uid);
	if ($object->firstchild)	ps_recurctrl($object->firstchild,$missing,$nbobject);
	if ($object->type==2)
	{
		$image=$object->data;
		if (!file_exists($image))
		{
			ps_message($image." manquante ! (".$object->name.")",2);
			$missing++;
		}
		else		$nbobject++;
	}
	if ($object->next)	ps_recurctrl($object->next,$missing,$nbobject);
}
/* effacer les images de travail */
function ps_rmfiles($files)
{
	$liste=glob($files);
	$nb=count($liste);
	if (!$nb)
	{
		ps_message("Aucun fichier à supprimer");
		return;
	}
	else		ps_message("Suppression de $nb fichier(s)");
	$idx=0;
	$errors=0;
	while (isset($liste[$idx]))
	{
		if (unlink($liste[$idx])===false)		$errors++;
		$idx++;
	}
	if ($errors)	ps_message("$errors erreur(s) lors de la suppression des fichiers ($dir)",1);
}
/* Exécution des commandes exec */
function ps_exec($cmd)
{
	putenv('LANG=fr_FR.UTF-8');
	exec($cmd,$out,$status);
	if ($status)
	{
		$_SESSION['message'][0]=2;
		$_SESSION['message'][1]="Erreur d'exécution de la commande ".$cmd;
		foreach ($out as $line)	ps_message($line);
		return false;
	}
	return true;
}
/* chercher si nom xl */
function ps_getxlname($name)
{
	$boom=explode("/",$name);
	$last=count($boom)-1 ;
	$boom[$last]="xl-".$boom[$last];
	$newname=implode("/",$boom);
	if (file_exists($newname))	return $newname;
	else							return $name;
}
?>
