<?php
	// Maintenir session ouverte si client en ligne
	session_name('index'); 
	session_start();
	if (!isset($_POST['command']))	exit("Error !");
	$retour=array();
	$cmd=$_POST['command'];
	if ($cmd=="ping")
	{
		$retour[0]="0";
		$retour[1]="pong";
		if (file_exists("tasks/pst.lock"))	$retour[2]=ping_barre();
		else								$retour[2]=false;
	}
	else
	{
		if ($cmd=="tasks")
		{
			$retour[0]="0";
			$retour[1]="tasks";
			$retour[2]=ping_tasks();
		}
		else
		{
			$retour[0]="1";
			$retour[1]="Invalid command !";
		}
	}
	echo (json_encode($retour));
/* liste des tâches */
function ping_tasks()
{
	$list=array();
	$tasks=glob("tasks/*.tsk");
	foreach ($tasks as $entry)
	{
		$tskfile=explode("\n",file_get_contents("$entry"));
		$name=basename($tskfile[2]);
		$pic=$tskfile[2]."/xs-".$name.".jpg";
		if (!file_exists($pic))		$pic="";
		$list[]=explode("\n",str_replace(array("tasks/",".tsk"),"",$entry)."\n".str_replace(array("<",">"),"",file_get_contents("$entry"))."\n".$pic);
	}
	return $list;
}
/* barre de progression */
function ping_barre()
{
	// tache active
	$lock=file_get_contents("tasks/pst.lock");
	if (!$lock)	return false;
	// données de la tâche
	$datalock=explode("\n",$lock);
	if (!isset($datalock[0]))	return false;
	$task=file_get_contents("tasks/".$datalock[0].".tsk");
	if (!$task)	return false;
	// renseignements utiles
	$taskdata=explode("\n",$task);
	if (count($taskdata)<3)	return false;
	if (!isset($taskdata[0])||$taskdata[0]!="<running>")	return false;
	$pourcent=explode("/",$taskdata[1]);
	$chemin=explode("/",$taskdata[2]);
	if (count($pourcent)<2 || count($chemin) < 3)	return false;
	$rg=array($chemin[1],$chemin[2],$pourcent[0],$pourcent[1]);
	return json_encode($rg);
}
?>
