<?php
	// Commandes utiles projet
	session_name('index'); 
	session_start();
	if (!isset($_POST['command'])||!$_SESSION['project'])	exit("Error !");

	$retour=array();
	$cmd=$_POST['command'];
	$chemin="projects/".$_SESSION['project'];
	require_once ("include/cfg.php");
	require_once ("projects/users.php");
	require_once ("lng/lng.php");
	switch ($cmd)
	{
		// lister toutes les scènes
		case "listall":
			//$_SESSION['lastcall']=time();
			$liste=pj_listscene($chemin);
			$retour[0]=1;
			$retour[1]=$liste;
			break;
		// Fabriquer une image
		//	$.post("pjutil.php",{command:"newtxtimage",scene:drawer,imagename:name,imagetxt:,fontname:,imagesize:,fontcolor:,gravity:}
		case "newtxtimage":
			$dir=$chemin."/".$_POST['scene']."/image";
			$retour=pj_addtxtimage($dir,$_POST['imagename'],$_POST['imagetxt'],$_POST['fontname'],$_POST['imagesize'],$_POST['gravity'],$_POST['fontcolor']);
			break;
		// Fabriquer une image halo
		case "newfhimage":
			$dir=$chemin."/".$_POST['scene']."/image";
			$retour=pj_addfhimage($dir,$_POST['imagename'],$_POST['imagesvg']);
			break;
		// Renommer les images
		//$.post("pjutil.php",{command:"renameimg",scenename:name,files:PJLIOrig,newname:NewList}, function (data) {
		case "renameimg":
			$old=$_POST['files'];
			$new=$_POST['newname'];
			$dir=$chemin."/".$_POST['scenename']."/image";
			for ($i=0;$i<count($old);$i++)	if ($new[$i]!="false")	pj_rename($dir,$old[$i],$new[$i]);
			$retour[0]=1;
			break;
		//  info vidéos
		case "infomnt":
			$liste=explode("\n",$_POST['mntlist']);
			$i=0;
			$message="";
			while (isset($liste[$i]) && $liste[$i])
			{
				$message.=pj_videoinfo($chemin."/".$liste[$i]."/".$liste[$i].".mp4")."<br>";
				$i++;
			}
			$retour[0]=1;
			$retour[1]=$message;
			break;
		// liste de montage
		case "listmnt":
			$retour[0]=1;
			$retour[1]=pj_listmnt($chemin);
			break;
		// enregistrer liste de montage
		//$.post("pjutil.php",{command:"savemnt",mntlist:data,action:domnt}, function (data) {
		case "savemnt":
			$liste=explode("\n",$_POST['mntlist']);
			for ($i=0;$i<count($liste);$i++)
			{
				if ($liste[$i])				$liste[$i]="file '../".$liste[$i]."/".$liste[$i].".mp4'";
				//$liste[$i]="file '".$chemin."/".$liste[$i]."/".$liste[$i].".mp4'";
			}
			file_put_contents("$chemin/commons/listmnt.txt",implode("\n",$liste));
			$retour[0]=1;
			if ($_POST["action"])
			{
				$mnt=pj_domnt($chemin,explode("\n",$_POST['mntlist']));
				if ($mnt)
				{
					$retour[0]=0;
					$retour[1]=_translate("Erreur lors du montage des vidéos")."<br>$mnt";
				}
			}
			break;
		// lister les images
		case "listimage":
			$liste=pj_listimage($chemin."/".$_POST['scene']."/image");
			$retour[0]=1;
			$retour[1]=$liste;
			break;
		// lister les sons
		case "listson":
			$liste=pj_listson($chemin,$_POST['scene']);
			$retour[0]=1;
			$retour[1]=$liste;
			break;
		// changer les params par défaut
		//$.post("pjutil.php",{command:"chgzero",scenename:name,anim:JSON.stringify(blankproj)}, function (data) {
		case "chgzero":
			$result=pj_chgzero($chemin."/".$_POST['scenename'],json_decode($_POST['anim']));
			if ($result)	$retour[0]=1;
			else
			{
				$retour[0]=0;
				$retour[1]=_translate("Erreur lors de l'enregistrement du fichier !");
			}
			break;
		// supprimer un son
		case "supprson":
		//$.post("pjutil.php",{command:"supprson",sndname:name}, function (data
			pj_supprson($chemin."/commons/sounds/",$_POST['sndname']);
			$retour[0]=1;
			$retour[1]="";
			break;
		// changer zéro
		//$.post("pjutil.php",{command:"chgson",scene: ,snd: ,spnd: ,sndlen: ,sndstrt: }
		case "chgson":
			// charger le zéro
			if (file_exists($chemin."/".$_POST['scene']."/anim.pst"))
			{
				$file=file_get_contents($chemin."/".$_POST['scene']."/anim.pst");
				$obj=json_decode($file);
				$obj[0]->snd=$_POST['snd'];
				$obj[0]->spsnd=$_POST['spsnd'];
				$obj[0]->sndlen=$_POST['sndlen'];
				$obj[0]->sndstrt=$_POST['sndstrt'];
				$pst=json_encode($obj);
				file_put_contents($chemin."/".$_POST['scene']."/anim.pst",$pst);
				$retour[0]=1;
			}
			else
			{
				$retour[0]=0;
				$retour[1]=_translate("Aucune animation n'a été créée");
			}
			break;
		// supprimer une image
		case "supprpic":
		//$.post("pjutil.php",{command:"supprpic",scenename:name,imagename:image}, function (data) {
			pj_supprimage($chemin."/".$_POST['scenename']."/image/",$_POST['imagename']);
			$retour[0]=1;
			$retour[1]="";
			break;
		// supprimer une video
		//$.post("pjutil.php",{command:"supprfilm",scenename:name}, function (data) {
		case "supprfilm":
			if ($_POST['scenename']=="commons")	$video=$_SESSION['project'].".mp4";
			else																	$video=$_POST['scenename'].".mp4";
			unlink($chemin."/".$_POST['scenename']."/".$video);
			$retour[0]=1;
			$retour[1]="";
			break;
		// supprimer une scène
		case "supprscene":
			//$.post("pjutil.php",{command:"supprscene",password:mdp,scenename:name}
			if (($ADMFlags&1) && ($ADMFlags&32))
			{
				if (hash('sha256',$_POST['password'])!=$ADMMdp)
				{
					$retour[0]="0";
					$retour[1]=_translate("Mot de passe incorrect !");
					break;
				}
			}
			$chemin="projects/".$_SESSION['project']."/".$_POST['scenename'];
			if (!file_exists($chemin))
			{
					$retour[0]="0";
					$retour[1]=_translate("Le répertoire n'existe pas !")." ($chemin)";
					break;
			}
			rrmdir($chemin);
			$retour[0]=1;
			break;
		case "addscene":
			//$.post("pjutil.php",{command:"addscene",scenename:name,drawername:filtred,anim:JSON.stringify(blankproj)}
			$dir="projects/".$_SESSION['project'];
			$drawer=$_POST['drawername'];
			$drawer=strict_filter($drawer);
			// vérif si existe déjà
			$savename=$drawer;
			$idx=2;
			while (file_exists("$dir/$drawer"))
			{
				$drawer=$savename."-".$idx;
				$idx++;
			}
			$idx--;
			// création des répertoires
			if (!mkdir("$dir/$drawer")||!mkdir("$dir/$drawer/image")||!mkdir("$dir/$drawer/anim"))
			{
				$retour[0]=0;
				$retour[1]=_translate("Erreur lors de la création du répertoire !")." ($drawer)";
				break;
			}
			// création du descriptif
			file_put_contents("$dir/$drawer/anim.name",$_POST['scenename']);
			// paramètres par défaut
			if ($drawer==$savename)
			{
				if (file_exists("$dir/commons/anim.pst"))	$zero=file_get_contents("$dir/commons/anim.pst");
				else										$zero=$_POST['anim'];
			}
			else					$zero=file_get_contents("$dir/$savename/anim.pst");
			if (!file_put_contents("$dir/$drawer/anim.pst",$zero))
			{
				$retour[0]=0;
				$retour[1]=_translate("Erreur lors de la création du fichier !")." $drawer.pst";
				break;
			}
			$date=date("d/m/Y", filemtime("$dir/$drawer"));
			$retour[0]=1;
			$retour[1]=array(1,$drawer,$_POST['scenename'],false,false,false,$date,pj_getzero("$dir/$drawer"));
			break;
		default:
			$retour[0]=0;
			$retour[1]="Invalid command !";
	}
	echo (json_encode($retour));
/*--- fonctions utiles ---*/
function pj_listscene($drawer)
{

	if (!is_dir($drawer))	return false;
	if (file_exists("$drawer/commons/".$_SESSION["project"].".mp4"))		$pvideo=true;
	else																								$pvideo=false;
	$retour=array();
	$retour[]=array(0,"");
	$retour[]=array(1,"commons",_translate("Communs"),false,false,$pvideo,date("d/m/Y", filemtime("$drawer/commons")),pj_getzero("$drawer/commons"));

	$dir=scandir($drawer);
	foreach($dir as $entry)
	{
		if ($entry!='.' && $entry!='..' && is_dir("$drawer/$entry") && $entry!="commons")
		{
			// nom
			if (file_exists("$drawer/$entry/anim.name"))	$name=file_get_contents("$drawer/$entry/anim.name");
			else											$name=$entry;
			// fichier image
			if (file_exists("$drawer/$entry/$entry.jpg"))
			{
				$pic=true;
				// miniature ?
				if (!file_exists("$drawer/$entry/xs-$entry.jpg"))
				{
					exec(PS_CONVCMD." $drawer/$entry/$entry.jpg -resize x160 $drawer/$entry/xs-$entry.jpg");
				}
			}
			else											$pic=false;
			// vidéo
			if (file_exists("$drawer/$entry/$entry.mp4"))	$video=true;
			else											$video=false;
			// lock ?
			$lock=pj_getlock("$drawer/$entry/anim.lock");
			// date et animation Zéro
			if (file_exists("$drawer/$entry/anim.pst"))	$date=date("d/m/Y", filemtime("$drawer/$entry/anim.pst"));
			else										$date=date("d/m/Y", filemtime("$drawer/$entry"));
			// set...
			$retour[]=array(1,$entry,$name,$lock,$pic,$video,$date,pj_getzero("$drawer/$entry"));
			// vérifier si dossier anim présent
			if (!file_exists("$drawer/$entry/anim"))	mkdir("$drawer/$entry/anim");
		}
	}
	return $retour;
}
function pj_getzero($entry)
{
	if (file_exists("$entry/anim.pst"))
	{
		$data=file_get_contents("$entry/anim.pst");
		$chaine=json_decode($data);
		$anim=json_encode($chaine[0]);
	}
	else
	{
		$anim=false;
	}
	return $anim;
}
/* liste de montage */
function pj_listmnt($dir)
{
	if (file_exists("$dir/commons/listmnt.txt"))	$liste=file_get_contents("$dir/commons/listmnt.txt");
	else																		$liste="";
	$list=explode("\n",$liste);
	$i=0;
	while (isset($list[$i]) && $list[$i])
	{
		$tmp=pathinfo(str_replace(["file ","'"],"",$list[$i]));
		$list[$i]=$tmp["filename"];
		$i++;
	}
	return $list;
}
/* effectuer le montage */
function pj_domnt($chemin,$liste)
{
	$destname=$chemin."/commons/".$_SESSION["project"].".mp4";
	$mntfile=$chemin."/commons/listmnt.txt";
	// vérification des vidéos
	$i=0;
	$size=$snd=$frate=0;
	while (isset($liste[$i]) && $liste[$i])
	{
		$message=pj_videocontrol($chemin."/".$liste[$i]."/".$liste[$i].".mp4",$size,$snd,$frate);
		$i++;
		if ($message)	return $message;
	}

	// go
	if (file_exists($destname))	unlink($destname);
	$cmdline=PS_FFCMD." -safe 0 -f concat -i $mntfile -c copy $destname";
	putenv('LANG=fr_FR.UTF-8');
	exec($cmdline,$out,$status);
	if ($status)
	{
	$cmdline.="<br>";
		foreach($out as $line)	$message.="$line<br>";
		return $cmdline;
	}
	else			return "";
}
/* controle des vidéos */
function pj_videocontrol($video,&$size,&$frate,&$snd)
{
	if (!file_exists($video))	return _translate("Vidéo manquante")." : ".$video;
	$output = shell_exec("ffprobe -v quiet -print_format json -show_format -show_streams \"$video\"");
	$params=json_decode($output);
	$tmpsize=$params->streams[0]->width."x".$params->streams[0]->height;
	if (isset($params->streams[1]))					$tmpsnd=2;
	else																	$tmpsnd=1;
	$tmpfrate=$params->streams[0]->r_frame_rate;
	if (!$size)	$size=$tmpsize;
	else				if ($size!=$tmpsize)	return _translate("Les vidéos doivent toutes avoir la même dimension !");
	if (!$snd)		$snd=$tmpsnd;
	else				if ($tmpsnd!=$snd)	return _translate("Certaines vidéos ont du son, d'autres non !");
	if (!$frate)	$frate=$tmpfrate;
	else				if ($tmpfrate!=$frate)	return _translate("Le nombre d'images / seconde doit être identique !");
	return "";
}
/* infos vidéos */
function pj_videoinfo($video)
{
	if (!file_exists($video))	return "<span style='color:red'>"._translate("Vidéo manquante")." : ".$video."</span><br>";
	$output = shell_exec("ffprobe -v quiet -print_format json -show_format -show_streams \"$video\"");
	$vdname=pathinfo($video);
	$retour="<span style='color:#008;font-weight:bold'>".ucfirst($vdname['filename'])."</span><br>";
	$params=json_decode($output);
	$retour.=_translate("Dimensions")." : ".$params->streams[0]->width."x".$params->streams[0]->height."<br>";
	$retour.=_translate("Sonorisé")." : ";
	if (isset($params->streams[1]))					$retour.="oui";
	else																	$retour.="non";
	$retour.="<br>"._translate("Images par seconde")." : ".$params->streams[0]->r_frame_rate."<br>";
	return $retour;
}
/* lister les images */
function pj_listimage($drawer)
{
	//return $drawer;
	if (!is_dir($drawer))	return false;
	require_once("pjuputils.php");

	$retour=array();
	$dir=scandir($drawer);
	foreach($dir as $entry)
	{
		if ($entry!='.' && $entry!='..' && is_file("$drawer/$entry"))
		{
			// lister
			$part=explode(".",$entry);
			if (isset($part[1]))	$extens=$part[1];
			else					$extens=false;
			$prefix=substr($entry,0,3);
			if ($prefix!="xl-" && $prefix!="xs-" && ispic($extens))
			{
				// test si xs- existe bien
				if (!file_exists("$drawer/xs-$entry"))
				{
					// création !
					exec(PS_CONVCMD." $drawer/$entry -resize x64 $drawer/xs-$entry");
				}
				// test si version xl-existe
				$name=$entry;
				if (file_exists("$drawer/xl-$entry"))	$name="xl-".$entry;
				// width / height
				$size=getimagesize("$drawer/$name");
				if ($size)
				{
					// Taille en pixel
					$width=$size[0];
					$height=$size[1];
					// Taille en ko
					$size=convertko(filesize("$drawer/$name"));
					// date
					$date=date("d/m/Y", filemtime("$drawer/$name"));
					// set...
					$retour[]=array(false,$entry,$width,$height,$size,$date);
				}
			}
		}
	}
	return $retour;
}
/* lister les sons */
function pj_listson($drawer,$scene)
{
	require_once("pjuputils.php");
	$retour=array();
	/* charger objet 0 */
	if (file_exists("$drawer/$scene/anim.pst"))
	{
		$scenedata=file_get_contents("$drawer/$scene/anim.pst");
		$sceneobj=json_decode($scenedata);
		if (isset($sceneobj[0]->snd) && isset($sceneobj[0]->spsnd))	$retour[]=array($sceneobj[0]->snd,$sceneobj[0]->spsnd,$sceneobj[0]->sndlen,$sceneobj[0]->sndstrt);
		else		$retour[]=array("","",0,0);
	}
	else $retour[]=array("","",0,0);
	/* lister les sons */
	$dir=glob("$drawer/commons/sounds/*.info");
	foreach ($dir as $entry)	$retour[]=explode("\n",file_get_contents($entry));
	return $retour;
}
/* supprimer un son */
function pj_supprson($drawer,$spname)
{
	if (!file_exists("$drawer$spname.info"))	return;
	$info=explode("\n",file_get_contents("$drawer$spname.info"));
	delsafe($drawer.$info[0]);
	delsafe("$drawer$spname.info");
	delsafe($drawer."S20-$spname.png");
	delsafe($drawer."S40-$spname.png");
	delsafe($drawer."S60-$spname.png");
	delsafe($drawer."S80-$spname.png");
}
function delsafe($file)
{
	if (file_exists($file))	unlink($file);
}
/* supprimer une image */
function pj_supprimage($drawer,$pic)
{
	delsafe($drawer.$pic);
	delsafe($drawer."xs-".$pic);
	delsafe($drawer."xl-".$pic);
}
/* lock du fichier ? */
function pj_getlock($file)
{
	$ret=false;
	if (file_exists($file))
	{
		$lock=file_get_contents($file);
		$time=time()-70;
		if ($lock<$time)	$ret=false;
		else				$ret=true;
	}
	return $ret;
}
// copy zéro
function pj_chgzero($dir,$zero)
{
	if (!file_exists("$dir/anim.pst"))
	{
		$chain=array();
		$chain[0]=$zero;
		$save=json_encode($chain);
		return	file_put_contents("$dir/anim.pst",$save);
	}
	// fichier
	//$zero=json_decode($zero);
	$chain=file_get_contents("$dir/anim.pst");
	if ($chain===false)	return false;
	// décode
	$chain=json_decode($chain);
	$chain[0]->photores = $zero->photores;
	//$chain[0]->resolution = $zero->resolution;
	$chain[0]->factorx = $zero->factorx;
	$chain[0]->factory = $zero->factory;
	// longueur
	$chain[0]->length = $zero->length;
	$save=json_encode($chain);
	return	file_put_contents("$dir/anim.pst",$save);
}
// recursively remove a directory
function rrmdir($dir)
{
    foreach(glob($dir . '/*') as $file) {
        if(is_dir($file))
            rrmdir($file);
        else
            unlink($file);
    }
    rmdir($dir);
}
// filtre strict nom rép.
function strict_filter($string)
{
	return preg_replace('/[^a-z0-9_-]/', '', $string); 
}
// tester si extension est jpeg ou png
function ispic($ext)
{
	if (strcasecmp($ext, "jpg")==0 || strcasecmp($ext, "png")==0)	return true;
	else															return false;
}
// ko humains
function convertko($octets)
{
	if ($octets<1024)	return $octets."&nbsp;octets";
	$octets=$octets/1024;
	if ($octets<1024)	return round($octets,1)."&nbsp;ko";
	$octets=$octets/1024;
	return round($octets,1)."&nbsp;mo";

}
// renommage
function pj_rename($dir,$old,$new)
{
	require_once("pjuputils.php");
	$interdit=array(" ","<",">","'","\"","`","xl-","xs-");
	$rpllist=array("_","","","_","","","xl_","xs_");
	$new=str_replace($interdit,$rpllist,$new);
	$new=up_getname($dir."/",$new);
	if (file_exists("$dir/xs-$old"))	rename("$dir/xs-$old","$dir/xs-$new");
	if (file_exists("$dir/xl-$old"))	rename("$dir/xl-$old","$dir/xl-$new");
	rename("$dir/$old","$dir/$new");
}
// création image texte
//$retour=pj_addtxtimage($picture,$_POST['imagetxt'],$_POST['fontname'],$_POST['imagesize'],$_POST['gravity'],$_POST['fontcolor']);
function pj_addtxtimage($dir,$picture,$imagetxt,$fontname,$size,$justify,$color)
{
	require_once("pjuputils.php");
	$retour=array(0,"");
	$idx=false;
	// chercher le ttf
	$ttf=explode("\n",file_get_contents("fonts/fonts.txt"));
	for ($i=0;$i<count($ttf);$i++)
	{
		if (strpos($ttf[$i],$fontname)!==false)
		{
			$idx=$i;
			break;
		}
	}
	// font ttf trouvée
	if ($idx!==false)
	{
		$picture=up_getname("$dir/",$picture);
		$fonts=explode("|",$ttf[$idx]);	// ttf : $fonts[1]
		//$dir=".";
		//$picture="DevelTest.png";
		$gravity="";
		if ($justify=="center")	$gravity=" -gravity center";
		if ($justify=="right")	$gravity=" -gravity east";
		$lignecom=PS_CONVCMD." -font 'fonts/".$fonts[1]."' -size x".$size."$gravity -background transparent -fill \"$color\" label:\"$imagetxt\" $dir/$picture";
		exec($lignecom);
		// do xs
		do_xs("$dir/",$picture);
		$retour[0]=1;
		$retour[1]=_translate("Image créée avec succès !");	//$lignecom;
	}
	else
	{
		$retour[0]=0;
		$retour[1]=_translate("Police de caractères non trouvée !");
	}
	return $retour;
}
// création image fond&halo
//$.post("pjutil.php",{command:"newfhimage",scene:drawer,imagename:name,imagesvg:svg}, function (data) {
function pj_addfhimage($dir,$picture,$svg)
{
	require_once("pjuputils.php");
	$retour=array(0,"");
	// sauver l'image
	$res=file_put_contents("$dir/$picture.svg",$svg);
	// convertir
	if ($res!==false)
	{
		$new=up_getname("$dir/","$picture.png");
		$lignecom=PS_PATH."inkscape --file=\"$dir/$picture.svg\" --export-png=\"$dir/$new\"";
		exec($lignecom);
		// do xs
		do_xs("$dir/",$new);
		unlink("$dir/$picture.svg");
		$retour[0]=1;
		$retour[1]=_translate("Image créée avec succès !");	//$lignecom;
		//$retour[2]=$svg;
	}
	else
	{
		$retour[0]=0;
		$retour[1]=_translate("Impossible de créer l'image !");
	}
	return $retour;
}
?>