<!DOCTYPE html>
<html>
<head>
<link rel="icon" type="image/png" href="data/psicona.png" />
<?php
/*
	Picstory v1.5
	Thomas Pimmel 2018
*/
session_name('index'); 
session_start();
if (!isset($_SESSION['project']) || !$_SESSION['project'])
{
	header("Location:index.php");      
	exit();
}
$project=$_SESSION['project'];
require ("include/cfg.php");
require ("projects/users.php");
require ("lng/lng.php");
CreateLang($ADMlng);
/* si dossier commons n'existe pas, le créer */
if (!file_exists("projects/$project/commons"))
{
	mkdir("projects/$project/commons");
	mkdir("projects/$project/commons/image");
}
print("<title>Picstory : "._translate("gestion des scènes")."</title>");
?>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="fonts/fonts.css" rel="stylesheet" type="text/css">
<link href="data/idx.css" rel="stylesheet" type="text/css">
<link href="data/project.css" rel="stylesheet" type="text/css">
<link rel='stylesheet' href='js/spectrum/spectrum.css' />
<?php
loadjs("js/jquery-3.3.1");
loadjs("js/jquery.md5");
loadjs("lng/lng");
loadjs("js/project");
loadjs("js/filter");
loadjs("fonts/fonts");
loadjs("js/spectrum/spectrum");
loadjs("js/ps_sound");
loadjs("js/ps_zero");
loadjs("js/pjmontage");
loadjs("js/infobulle");
?>
</head>
<body> <!--onclick='pj_leftmouse(event);'>-->
<div id="maindiv">
<?php
/* Flags admin */
print("<script>var ADMFlags=".$ADMFlags.";\nvar PJProject='$project';</script>");
/**** Entête et déco **********/
/* fenêtre popup */
print("<div id='grise'><div id='popup'></div></div>");
print("<div id='displayimage' onclick='pj_showimage(false)'></div>");
/* Barre de titre */
print("<div class='titleleft' onmouseover='_IB(this,\""._translate("Revenir au menu<br>principal")."\");' onclick='pj_exit(event)'><img src='data/adm/exit.svg'></div>");
print("<div id='titleright'>0 ms</div>");
/* titre */
print("<div class='mainleft' style='font-size:1.4em;'><span>P</span><span style='font-style:italic;color:rgba(50,200,50,.8);font-size:1.2em;");
print("margin-right:-.1em;margin-left:-.2em'>i</span><span>cStory</span><span style='font-size:.8em'>");
print(" &laquo;&nbsp;".$_SESSION['projname']."&nbsp;&raquo;</span><span> "._translate("gestion des scènes")."</span></div>");
print("<div id='maintitle'></div>");
print("<form action='ps_picstory.php' method='post'>
<input type='hidden' name='prjscene' id='selectedscene' value=''>
<input type='hidden' name='prjproject' value='".$_SESSION['project']."'>");
print("<div id='leftpanel'><div id='leftruban'></div></div><div id='middlepanel'><div id='middleruban'></div></div>");
print("</form>");
/* chargement des javascript */
function loadjs($js)
{
	if (file_exists("$js.min.js"))	print("<script src='$js.min.js'></script>\n");
	else							print("<script src='$js.js'></script>\n");
}
?>
</div>
</body>
</html>
